/* XPlasma.c - Release version - Copyright (c) 1995 Denis Auroux.
   Contact for any comments or questions : auroux@clipper.ens.fr   */

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <sys/time.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#define MAXPAL 4096

#define NCOLORS 128
#define COLSHIFT 1

static char *windowname="xplasma";

Display *dpy;
int scr;
Window root,ctlwin;
int h,w;
Pixmap pixmap;
Colormap cmap;
XImage *ximage;
Visual *visu;
unsigned char **data;
unsigned char *data2;
unsigned char rgb[3][256];
GC gc;
XColor xcolor;
XColor mycolors[NCOLORS];
XGCValues gcv;
int x,y,i;
unsigned long pixent[NCOLORS];
int t[3],dt[3],ddt[3];
int ststop;
char **argv;
int argc;
XtAppContext application_context;
Arg args[2];

bug(char *s)
{
 fprintf(stderr,"%s\n",s);
 exit(1);
}

time_randomize()
{
 struct timeval tp;
 
 gettimeofday(&tp,NULL);
 srand(tp.tv_usec);
}

makeimage()
{
 int i,j,k,x,y,t;
 unsigned int r;

 fprintf(stderr,"Building pixmap... ");
 for (x=0;x<w;x++) for (y=0;y<h;y++) data[y][x]=128;
 for (k=7;k>0;k--) {
   fprintf(stderr,"%d ",k);
   for (j=0;j<=((h-1)>>k);j++)
     for (i=0;i<=((w-1)>>k);i++)
       {
         t=(data[j?(j-1)<<k:((h-1)>>k)<<k][i<<k]+
            data[j<<k][(((i+1)<<k)<w)?(i+1)<<k:0]+
            data[j<<k][i?(i-1)<<k:((w-1)>>k)<<k]+
            data[(((j+1)<<k)<h)?(j+1)<<k:0][i<<k])>>2;
         if (k>=3) { r=rand(); t+=(r>>8)%(1<<(k+1))-(1<<k); }
         if (t>255) t=255;
         if (t<1) t=1;
   /*      for (x=i<<k;x<(i+1)<<k;x++) 
          for (y=j<<k;y<(j+1)<<k;y++) */
	 data[j<<k][i<<k]=t;
	 if (k) {	     
	 if ((j<<k)+(1<<(k-1))<h) data[(j<<k)+(1<<(k-1))][i<<k]=t;
	 if ((i<<k)+(1<<(k-1))<w) { data[j<<k][(i<<k)+(1<<(k-1))]=t;
	    if ((j<<k)+(1<<(k-1))<h) data[(j<<k)+(1<<(k-1))][(i<<k)+(1<<(k-1))]=t;
				}   } 
     }
 }
 for (x=0;x<w;x++) for (y=0;y<h;y++) data[y][x]=pixent[data[y][x]>>COLSHIFT];
 fprintf(stderr,"\n");
}

ctlwindow()
{
    XColor c1,c2,c3;
    unsigned char bmp[20*40];
    int i,j;
    XImage *ximage;
    Pixmap pixmap;
    unsigned int a,b;
    Widget toplevel;

    toplevel=XtAppCreateShell(windowname,windowname,applicationShellWidgetClass,dpy,NULL,0);
    XtGetApplicationResources(toplevel,NULL,NULL,0,NULL,0);
    
/*    XtSetArg(args[0], XtNx, NULL);
    XtSetArg(args[1], XtNy, NULL);
    XtGetValues (toplevel, args, 2); */
    XtSetArg(args[0], XtNwidth, 40);
    XtSetArg(args[1], XtNheight, 20);
    XtSetValues (toplevel, args, 2);

    XtRealizeWidget(toplevel);

    ctlwin=XtWindow(toplevel);
    XSelectInput(dpy,ctlwin,ButtonPressMask);
    XMapWindow(dpy,ctlwin);
    XFlush(dpy);
    
    c1.red=0; c1.green=0xffff; c1.blue=0;
    if (!XAllocColor(dpy,cmap,&c1)) bug("Color allocation error");
    c2.red=0xffff; c2.green=0xffff; c2.blue=0;
    if (!XAllocColor(dpy,cmap,&c2)) bug("Color allocation error");
    c3.red=0xffff; c3.green=0; c3.blue=0;
    if (!XAllocColor(dpy,cmap,&c3)) bug("Color allocation error");
    for (i=0;i<=19;i++) for (j=0;j<=i;j++) bmp[40*i+j]=c1.pixel;
    for (i=0;i<=19;i++) for (j=i;j<=19;j++) bmp[40*i+j]=c2.pixel;
    for (i=0;i<=19;i++) for (j=20;j<=39;j++) bmp[40*i+j]=c3.pixel;
    pixmap=XCreatePixmap(dpy,ctlwin,40,20,8);
    ximage=XCreateImage(dpy,visu,8,ZPixmap,0,bmp,40,20,8,40);
    gcv.function=GXcopy;
    gc=XCreateGC(dpy,pixmap,GCFunction,&gcv);
    XPutImage(dpy,pixmap,gc,ximage,0,0,0,0,40,20);
    XSetWindowBackgroundPixmap(dpy,ctlwin,pixmap);
    XFlush(dpy); 
    XClearWindow(dpy,ctlwin);
    XFlush(dpy); 
}

/* patch pour tvtwm... */
static Window VirtualRootWindow(Display *dpy,int scr)
{
    Atom actual_type,__SWM_VROOT=None;
    Window root,rootR,parent,*children,*newRoot;
    unsigned int n;
    int i,actual_format;
    unsigned long nitems,bytesafter;
    
    root=RootWindow(dpy,scr);
    __SWM_VROOT=XInternAtom(dpy,"__SWM_VROOT",False);
    XQueryTree(dpy,root,&rootR,&parent,&children,&n);
    for (i=0;i<n;i++)
	if (XGetWindowProperty(dpy,children[i],__SWM_VROOT,0,1,False,XA_WINDOW,
			       &actual_type,&actual_format,&nitems,&bytesafter,
			       (unsigned char **) &newRoot) == Success && newRoot)
	{ root=*newRoot; break; }
    return root;
}


main(int argsc, char **argsv)
{
 argv=argsv;
 argc=argsc;
 time_randomize();

 XtToolkitInitialize();
 application_context=XtCreateApplicationContext();
 dpy=XtOpenDisplay(application_context,NULL,windowname,windowname,NULL,0,&argc,argv);

 if (dpy==NULL) bug("Can't open display");
 scr=DefaultScreen(dpy);
 root=VirtualRootWindow(dpy,scr);

 h=DisplayHeight(dpy,scr);
 w=DisplayWidth(dpy,scr);
 
/* h=(h+127)&(0xffffff80);
 w=(w+127)&(0xffffff80); */

 if (!(data2=(unsigned char *)malloc(h*w))) bug("Not enough memory");
 if (!(data=(unsigned char **)malloc(h*sizeof(char *)))) bug("Not enough memory");
 for (i=0;i<h;i++) data[i]=data2+i*w;
 
 if (DisplayPlanes(dpy,scr)!=8) bug("Not an 8-bit display");
 visu=DefaultVisual(dpy,scr);

 pixmap=XCreatePixmap(dpy,root,w,h,8);
 cmap=DefaultColormap(dpy,scr);
 ctlwindow();

 if (!XAllocColorCells(dpy,cmap,False,NULL,0,pixent,NCOLORS)) bug("Colormap is full");
 for (i=0;i<NCOLORS;i++) mycolors[i].pixel=pixent[i];
 for (i=0;i<NCOLORS;i++) mycolors[i].flags=DoRed|DoBlue|DoGreen;
 
 makeimage();
 
 ximage=XCreateImage(dpy,visu,8,ZPixmap,0,(unsigned char *)&(data[0][0]),w,h,8,w);
 gcv.function=GXcopy;
 gc=XCreateGC(dpy,pixmap,GCFunction,&gcv);
 XPutImage(dpy,pixmap,gc,ximage,0,0,0,0,w,h);
 XSetWindowBackgroundPixmap(dpy,root,pixmap);

 XFlush(dpy); 
 XClearWindow(dpy,root);
 XFlush(dpy); 
 
 nice(10);
 for (i=0;i<=63;i++) { rgb[0][i]=rgb[1][i]=0; rgb[2][i]=i;
                       rgb[0][64+i]=rgb[1][64+i]=i; rgb[2][64+i]=63;
		       rgb[0][191-i]=63; rgb[1][191-i]=rgb[2][191-i]=i;
		       rgb[0][255-i]=i; rgb[1][255-i]=rgb[2][255-i]=0; }
 for(i=0;i<=2;i++) { t[i]=0; dt[i]=0; ddt[i]=1; }
 ststop=1;

 for(;;)
   {
       if (XEventsQueued(dpy,QueuedAfterReading)) 
       {
	   XEvent ev;
	   XNextEvent(dpy,&ev);
	   if ((ev.type==ButtonPress)&&(ev.xbutton.window==ctlwin)) 
	   {
	       XSetWindowBackgroundPixmap(dpy,DefaultRootWindow(dpy),None);
	       XClearWindow(dpy,DefaultRootWindow(dpy));
	       XFlush(dpy);
	       
	       XSetWindowBackgroundPixmap(dpy,root,ParentRelative);
	       XClearWindow(dpy,root);
	       
	       XFlush(dpy);

	       if (ev.xbutton.x<20) {
		   ststop=!ststop;
		   if (ststop)
		   {
		       XSetWindowBackgroundPixmap(dpy,root,pixmap);
		       XClearWindow(dpy,root);
		       XFlush(dpy);
		   }
	       }
	       else { XFreeColors(dpy,cmap,pixent,NCOLORS,0); exit(0); }
	   }
       }
     usleep(40000);
 if (ststop) {       
     for (x=0;x<NCOLORS;x++) { 
       mycolors[x].red=rgb[0][x<<COLSHIFT]<<10;
       mycolors[x].green=rgb[1][x<<COLSHIFT]<<10;
       mycolors[x].blue=rgb[2][x<<COLSHIFT]<<10;
   }
     XStoreColors(dpy,cmap,mycolors,NCOLORS);
     XFlush(dpy);
     
     for(i=0;i<=2;i++)
       {
         if (!(rand()&0xf000)) ddt[i]=-ddt[i]; 
	 if (t[i]<(MAXPAL>>3)) ddt[i]=1;
	 if (t[i]>MAXPAL-(MAXPAL>>3)) ddt[i]=-1;
	 dt[i]+=ddt[i];
	 if (dt[i]>60) dt[i]=60;
	 if (dt[i]<-60) dt[i]=-60;
	 t[i]+=dt[i];
	 if (t[i]<0) t[i]=0;
	 if (t[i]>=MAXPAL) t[i]=MAXPAL-1;
	 for (x=1;x<=255;x++) rgb[i][x-1]=rgb[i][x];
	 rgb[i][255]=t[i]>>6;
       }
   }
   }
}
